function vl = lim_var( v, tol )
%
% lim_var -- limit variance from below
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:39:23 $

if nargin<2,
  tol = eps;
end

% SVD
[u,s,v] = svd(v);

% Limit variance from below
s = abs(diag(s));
s(find(s<tol)) = tol;

% Reconstruct
vl = u*diag(s)*v';
