%
% LOGSUM -- weighted sum of elements in log domain
%           sum(x) = exp( logsum( log(x) ) )
% 
% Usage:
%   s = logsum(a,dim,w)
% Input:
%   a		array
%   dim		dimension of summation (default 1)
%   w		summation weights (default 1)
% Output:
%   s		log sum along dimension 'dim' weighted by weights in 'w'
%
% Example:
%   p = [.3; 0; .7]
%   sum(p) = 1
%   logsum( log(p) ) = 0
%
% See also:
%   wsum, sum
%

% Uses MEX file

%	$Revision: 2.0 $ $Date: 2000/04/24 17:39:23 $
