/* $Revision: 2.0 $ $Date: 2000/04/24 17:39:05 $ */

#ifndef _MATH_UTIL_H_
#define _MATH_UTIL_H_

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>

#ifdef _WIN32
#define finite(x) _finite(x)
#define isnan(x) _isnan(x)
#endif

#ifndef HUGE
#define HUGE HUGE_VAL
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern void	emf_clean();  

extern double	logSum( double x, double y);
extern double	cost( double *Scale, int T);
extern void	lin2log(double *x, int N);
extern void	log2lin(double *x, int N);

extern int	choldc(double *a, int N, double *p);
extern void	invchol(double *a, double *p, int N);
extern int	sinv( double *A, int N, double *invA, double *detA );
extern double*	sinv_( double *A, int N );
extern void	lpvprod(double *L, double *p, double *v, int N, double *Lv);
extern int	mnorm(double *A, double *v, int N, int M, double *d);
extern void	oquadop( double alpha, double *A, double *x, double *B, 
			 int N, int M, int Mo, double *y );
extern void	linop( double alpha, double *A, double *x, double *b, 
		       int N, int M, int S, double *y );

extern void	printm( double *x, int N, int M);
extern void	copy(double *x, int N, double *y);
extern double*	copy_(double *x, int N);
extern void	neg(double *x, int N, double *y);
extern double*	neg_(double *x, int N);
extern void	scale(double *x, double alpha, int N, double *y);
extern double*	scale_(double *x, double alpha, int N);
extern void	trans( double *x, int N, int M, double *y);
extern double*	trans_(double *x, int N, int M);
extern double	wnorm( double *W, double *x, int N );
extern double	trace( double *x, int N );
extern void	sum(double *x, double *y, int N, double *z);
extern double*	sum_(double *x, double *y, int N);
extern void	diff(double *x, double *y, int N, double *z);
extern double*	diff_(double *x, double *y, int N);
extern void	prod(double *x, double *y, int N, int L, int M, double *z);
extern double*	prod_(double *x, double *y, int N, int L, int M);
extern void	dot(double *x, double *y, int N, int L, int M, double *z);
extern double*	dot_(double *x, double *y, int N, int L, int M);
extern void	out(double *x, double *y, int N, int L, int M, double *z);
extern double*	out_(double *x, double *y, int N, int L, int M);
extern void	iqprod(double *A, double *x, double *B, int N, int M, double *y);
extern double*	iqprod_(double *A, double *x, double *B, int N, int M);
extern void	oqprod(double *A, double *x, double *B, int N, int M, double *y);
extern double*	oqprod_(double *A, double *x, double *B, int N, int M);


#ifdef __cplusplus
	       }
#endif

#endif /* _MATH_UTIL_H_ */
