function plotlab(lab,pos,color)
%
% plotlab -- add state labels to current plot
%
% Usage:
%   plotlab(label,pos,color)
% Input:
%   label	list of labels
%   pos		label position [x1 x2 y1 y2]
%   color	label color (default [1 0 0], i.e., red)

%	$Revision: 2.0 $ $Date: 2000/04/24 17:39:24 $

sqX = [0 1 1 0];
sqY = [0 0 1 1];

xLim = get(gca,'xLim');
yLim = get(gca,'yLim');

if nargin<3,
  color = [1 0 0];
end

L = length(lab);

if size(pos,1)<3,
  pos(3,:) = yLim(ones(1,L));
end

if size(pos,1)<4,
  pos(4,:) = yLim(2*ones(1,L));
end

for i = 1:length(lab),
  
  sx = pos(1,i);  
  ex = pos(2,i);
  
  sy = pos(3,i);
  ey = pos(4,i);
     
  h=line(sqX*(ex-sx)+sx,sqY*(ey-sy)+sy);
  set(h,'linestyle',':');  set(h,'color',color); set(h,'linewidth',.25);
  
  % Hack to get text box dimensions
  h = text(inf,inf,lab(i)); set(h,'rotation',90);
  tbox = get(h,'extent');
  
  h=text( (sx+ex)/2, (sy+ey-tbox(4))/2, lab(i) );
  set(h,'rotation',90); set(h,'color',color);
  
  
end

set(gca,'xLim',xLim);









