function plotseg(data,idx,type,thd,bar)
%
% plotseg -- plot function with segments of different colors
%
% Usage:
%   plotseg(data,idx,type)
%
% Input:
%   data	f( t )
%   idx		color( t )
%   type	'color' -- use color
%		'line'  -- use line types
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:39:24 $

if (nargin<3)
  type = 'color';
end

if nargin<4,
  thd = 0;
end

if nargin<5,
  bar = 0;
end

if size(idx,1)>1
  M = size(idx,1);
else
  M = max(idx(:));
end

del  = diff(idx,1,2);
didx = [1 find(max(abs(del),[],1)>thd) length(data)];

if ( strcmp(type,'color') )
  line = { 'y' 'm' 'c' 'r' 'g' 'b' 'k' };
else
  line  = { '-' ':' '-.' '--' };
end

cmap = hsv(M);

next = 1;
holdstate = ishold;

if (~ishold)
  cla;
end

hold on;
for k=1:length(didx)-1,
  
  I = didx(k):didx(k+1);
  h = plot(I,data(:,I)', line{next});
  if (strcmp(type,'color'))
    cidx = mean(idx(:,I),2);
    if length(cidx)>1,
      color = cidx'*cmap;
      color(find(color>1))=1;
      color(find(color<0))=0;
    else
      color = cmap(cidx,:);
    end
    set(h,'color',color);
  end
  
  if (next<min(length(line),M))
    next = next + 1;
  else
    next = 1;
  end
  
end

if bar,
  
  h = colorbar; N = get(h,'clim'); 
  colormap( hsv2rgb( [ (0:(M-1)/(M*(N(2)-1)):((M-1)/M))' ones(N(2),2)] ) );
  lim = get(h,'ylim'); del = (lim(2)-lim(1))/(M-1);
  set(h,'ytick',lim(1):del:lim(2));
  set(h,'yticklabels',1:M);
  
end

if (holdstate==0)
  hold off
end
