/* $Revision: 2.0 $ $Date: 2000/04/24 17:39:17 $ */

#include "mex.h"
#include <math.h>
#include "math_util.h"

#define GET_TOTAL_ELEMENTS(a)  (mxGetM(a) * mxGetN(a)) 
#undef DEBUG

/* Input Arguments */

#define IN	prhs[0]

/* Output Arguments */

#define OUT	plhs[0]
#define DET	plhs[1]

void 
mexFunction(
	    int nlhs,       mxArray *plhs[],
	    int nrhs, const mxArray *prhs[]
	    )
{
  double	*pIn, *pOut, *pDet;
  int		N;

  /* Check for proper number of arguments */
  
  if (nrhs != 1)  {
    mexErrMsgTxt("Requires one input argument.");
  } else if (nlhs > 2) {
    mexErrMsgTxt("Requires at most two output argument.");
  }
  
  /* Get input pointers */
  pIn  = mxGetPr( IN );
  N    = mxGetN( IN );

  /* Create outputs */
  OUT	= mxCreateDoubleMatrix(N, N, mxREAL);
  DET	= mxCreateDoubleMatrix(1, 1, mxREAL);

  /* Set output pointers */
  pOut = mxGetPr( OUT );
  pDet = mxGetPr( DET );

  if ( sinv(pIn, N, pOut, pDet ) < 0 ) {
    mexWarnMsgTxt("Matrix is not positive definite.");
  }

  return;
}
