%
% Factor analyzer (FA)
% ====================
%
% Model:
%  
%   x = m + v		E[v] = 0, E[vv'] = Q
%   y = C x + w		E[w] = 0, E[ww'] = R
%			          E[vw'] = 0
%
% Notation:
%
%   x		factor
%   y		observation
%   N		dim(x)
%   M		dim(y)
%   m		factor mean
%   Q		factor variance
%   C		loading matrix
%   R		observation noise variance
%
% Functions:
%
%   fa_sim	sample from FA
%   fa_infr	inference in FA
%   fa_learn	learn FA parameters
%   fa_init	initialize FA parameters
%
% Related toolkits:
%
%   mog		mixture of Gaussians toolkit
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:37 $
