function cost = fa_cost(m,Q,C,R, Ex,Exx,Eyx,Eyy)
%
% fa_cost -- FA model cost
% 
% Usage:
%  cost = fa_cost(m,Q,C,R, Ex,Exx,Eyx,Eyy)
% See also:
%  fa_learn
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:39 $

[invQ,detQ]   = sinv(Q);
[invR,detR]   = sinv(R);
[M,N] = size(C);

const = log(2*pi);

cost = trace( invR*Eyy )/2 - trace( C'*invR*Eyx ) ...
       + trace( C'*invR*C*Exx )/2 + 1/2*log(detR) + M/2*const...
       + trace( invQ*Exx )/2 - Ex'*invQ*m + m'*invQ*m/2 + 1/2*log(detQ) ...
       + N/2*const;

