function [cost,ex,vx] = fa_infr(Y,m,Q,C,R)
%
% fa_infr -- inference in FA
%
% Usage:
%   [cost,ex,vx] = fa_infr(Y,m,Q,C,R)
% Input:
%   Y		observations
%   m		factor mean
%   Q		factor variance
%   C		factor loading matrix
%   R		observation noise variance
% Output:
%   cost	-log{P(y)}/sample
%   ex		E[x|y]
%   vx		Var[x|y]
% Global:
%   FA_INFERENCE_MODE	'exact' - exact inference
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:40 $

global FA_INFERENCE_MODE
if (~isempty(FA_INFERENCE_MODE))
  inferMode = FA_INFERENCE_MODE;
else
  inferMode = 'exact';
end

switch( lower(inferMode) ),
  
 case 'exact',
  
  [cost,ex,vx] = fa_smt(Y,m,Q,C,R);
  
 otherwise,
    
  error( sprintf('Unknown FA_INFERENCE_MODE option %s.', upper(inferMode)) );
  
end
