function [m,Q,C,R] = fa_max(ex,exx,eyx,eyy, m,Q,C,R)
%
% fa_max -- maximization of FA parameters wrt current stats
%
% Usage:
%   [m,Q,C,R] = fa_max(ex,exx,eyx,eyy, m,Q,C,R)
% See also:
%   fa_learn

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:40 $

global FA_NL_C FA_NL_R FA_NL_m FA_NL_Q
global FA_MIN_VAR

if isempty(FA_MIN_VAR)
  tol = 1e-3;
else
  tol = FA_MIN_VAR;
end

[M,N] = size(eyx);

if (isempty(FA_NL_C))
  C = eyx * sinv( exx );
end

if (isempty(FA_NL_R))
  R = eyy - C*eyx' - eyx*C' + C*exx*C';
  R = diag( diag(R) );
  R = lim_var( R, tol );
end

if (isempty(FA_NL_m))
  % m = ex;
  m = zeros(N,1);
end

if (isempty(FA_NL_Q))
  % Q = exx - m*m'; % Q can be fixed as eye(N)
  Q = eye(N);
end
   
