function [Eys,Ess,Es0,Ts] = dhmm_ucs(Y,es,cs, Eys,Ess,Es0,Ts, P,Q,p0, w)
%
% hmm_ucs -- update discrete mixture HMM statistics
%
% Usage:
%   [Eys,Ess,Es0,Ts] = 
%         dhmm_ucs( Y, es,cs,ec, Eys,Ess,Es0,Ts, P,Q,p0, w )
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:55 $

if nargin<11,
  w=1;
end

% Update cumulative scores

T = size(Y,2);
[M,N] = size(Eys);

basisY = eye(M);

Eys = Eys + w*basisY(:,Y)*es';	% sum_{t=0}^{T-1} y(t) E[s_t]

Es0 = Es0 + w*es(:,1);		% E[s_0]

Ess = Ess + w*sum( cs, 3);	% sum_{t=0}^{T-2} E[s_t s_{t-1}']

Ts = Ts + w*T;
