function cost = ghmm_cost(P,Q,C,R,p0, Ecs,Ess,Es0,Dss,Eyycs,Eycs,T)
%
% ghmm_cost -- cost of GHMM
%
% Usage:
%   cost = ghmm_cost(P,Q,C,R,p0, Ecs,Ess,Es0,Dss,Eyycs,Eycs,T)
% See also:
%   hhmm_learn
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:57 $

[M,N] = size(Q);
D = size(C,1);
d = ndims(R)-ndims(C);

const = log(2*pi);

sIdx = find(Ess);
  
cost = - log(p0(sIdx)+realmin)'*Es0(sIdx) ...
    - trace( log(P(sIdx,sIdx)+realmin)*Dss(sIdx,sIdx)' );

for c=1:M,
  for s=sIdx',
      
    if (Q(c,s))
      
      if (d),
	cost = cost -log(Q(c,s)+realmin)*Ecs(c,s) ...
	    + trace( inv(R(:,:,c,s))*( Eyycs(:,:,c,s) ...
	    - C(:,c,s)*Eycs(:,c,s)' ...
	    - Eycs(:,c,s)*C(:,c,s)' ...
	    + C(:,c,s)*Ecs(c,s)*C(:,c,s)' )/2) ...
	    + ( log(det(R(:,:,c,s))) + const*D )*Ecs(c,s)/2;
      else
	cost = cost - log(Q(c,s)+realmin)*Ecs(c,s) ... 
	    + sum( ( Eyycs(:,c,s) - 2*C(:,c,s).*Eycs(:,c,s) ...
	    + C(:,c,s).^2*Ecs(c,s) )./R(:,c,s) )/2 ...
	    + ( log(prod(R(:,c,s))) + const*D )*Ecs(c,s)/2;
      end   

    end
      
  end
end

