function varargout = hmm_gauss(varargin)
%
% hmm_gauss -- Gaussian distribution kernel
%
% Usage:
%   hmm_gauss(C,R)	- set kernel parameters
%   x = hmm_gauss(s)	- sample from 's'-th parameter set
%   [C,R] = hmm_gauss	- get kernel parameters
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:44:00 $

global HMM_GAUSSIAN_C HMM_GAUSSIAN_R

if (nargin==2)
  
  % Set parameters
  HMM_GAUSSIAN_C = varargin{1};
  HMM_GAUSSIAN_R = varargin{2};
  
elseif (nargin==1)
  
  % Simulate observation
  M = size(HMM_GAUSSIAN_C,1);
  T = size(varargin{1},2);
  
  r = randn(M,T);
    
  for t=1:T,
   
    s = varargin{1}(t);

    % So far only on diagonal variance
    x(:,t) = HMM_GAUSSIAN_C(:,s) + sqrt( HMM_GAUSSIAN_R(:,s) ).* r(:,t);
    
  end
  
  varargout{1} = x;
  
else
  
  varargout{1} = HMM_GAUSSIAN_C;
  varargout{2} = HMM_GAUSSIAN_R;

end
    
