function cost = lds_cost(A,C,Q,R,x0,Q0,Exx,ExxD,Exx1,ExxT,Eyx,Eyy,Exx0,T)
%
% lds_cost -- cost of LS model
%
% See also:
%   lds_learn
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:20 $

[invQ,detQ]   = sinv(Q);
[invQ0,detQ0] = sinv(Q0);
[invR,detR]   = sinv(R);

cost = trace( invR*Eyy )/2 - trace( C'*invR*Eyx ) ...
    + trace( invR*C*Exx*C' )/2 + T/2*log(detR) ...
    + trace( invQ*( (Exx-Exx1) - 2*A*ExxD' + A*(Exx-ExxT)*A' ) )/2 ...
    + (T-1)/2*log(detQ) ...
    + trace( invQ0*Exx0 )/2 + log(detQ0)/2;

