function [a,c,q,r,x0,q0] = lds_max( Eyy,Eyx,Exx,ExxD,ExxT,Exx1,Ex0,Exx0, ...
    T, a,c,q,r,x0,q0)
%
% lds_max -- maximization of LS model parameters
%
% See also:
%   lds_learn
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:22 $

global LS_MIN_VAR
global LS_NL_A LS_NL_C LS_NL_Q LS_NL_R LS_NL_X0

if (isempty(LS_MIN_VAR))
   tol = 1e-3;
else
   tol = LS_MIN_VAR;
end

if (isempty(LS_NL_C))
  c = Eyx*sinv( Exx );
end

if (isempty(LS_NL_R))
  r = ( Eyy - c*Eyx' - Eyx*c' + c*Exx*c')/T;
  r = lim_var( r, tol );
end


if (isempty(LS_NL_A))
  a = ExxD*sinv( Exx - ExxT );
end


if (isempty(LS_NL_X0))
  x0 = Ex0;
end


if (isempty(LS_NL_Q))
  q = ( Exx - Exx1 - a*ExxD' - ExxD*a' + a*(Exx-ExxT)*a' )/(T-1);
  q = lim_var( q, tol );

  q0 = Exx1 - Ex0*x0' - x0*Ex0' + x0*x0';
  q0 = lim_var( q0, tol );
end

