function [a,c,q,r,x0,q0] = ...
    lds_max_offset( Eyy,Eyx,Exx,ExxD,ExxT,Exx1,Ex0,Exx0, T, a,c,q,r,x0,q0)
%
% lds_max_offset -- maximization of LS model parameters
%
% See also:
%   lds_max, lds_learn
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:23 $

global LS_MIN_VAR

if (isempty(LS_MIN_VAR))
   tol = 1e-3;
else
   tol = LS_MIN_VAR;
end

[M,N] = size(Eyx);
t0 = 1:M;
t1 = M+1:N;

% State transition matrix
a(t0,:)  = ExxD(t0,:)*sinv( Exx - ExxT );
a(t1,t1)   = eye(N-M);
  
% Initial state
x0  = Ex0;

% State noise variance
qc = ( Exx - Exx1 - a*ExxD' - ExxD*a' + a*(Exx-ExxT)*a' ) / (T-1);
qc = lim_var(qc,tol);
q  = zeros(N); q(t0,t0) = qc(t0,t0);

q0 = Exx1 - Ex0*x0' - x0*Ex0' + x0*x0';
q0 = lim_var(q0,tol);

% Measurement matrix
c = [ eye(M) zeros(M,N-M) ];

% Measurement noise variance
r = ( Eyy - c*Eyx' - Eyx*c' + c*Exx*c' )/T;
r = lim_var(r,tol);
