function [C,R,ex] = lds_oinit(Y,N,M,S,errThd)
%
% See lds_init
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:23 $

global LS_NL_A LS_NL_C LS_NL_Q LS_NL_R LS_NL_X0
global FA_NL_C FA_NL_R

if (N<=M)
  
  % Use factor analysis
  if (isempty(LS_NL_C))
    FA_NL_C = [];
  else
    FA_NL_C = 1;
  end
  
  if (isempty(LS_NL_R))
    FA_NL_R = [];
  else
    FA_NL_R = 1;
  end
  
  % Initialize factor analysis
  [C,R] = fa_init(Y,N);
  Q = eye(N);
  m = zeros(N,1);
  
  % Learn parameters
  [m,Q,C,R] = fa_learn(Y, m,Q,C,R, errThd);
  
  % Smooth out data
  [cost,ex,vx] = fa_infr(Y, m,Q,C,R);
  
else
  
  % Use AR1 model
  
  if (isempty(LS_NL_R))
    cX = Y*Y'/( S*(size(Y,2)-S) );
    R  = diag(diag(cX))/2;
  else
    R = eye(M);
  end
  
  if (isempty(LS_NL_C))
    [u,s,v] = svd(cX-R);
    C  = u*[sqrtm(s) zeros(M,N-M)];
    C  = C + randn(M,N)*max(max(abs(C)))/20;
  else
    C = eye(M,N);
  end
  
  beta = C'*inv(C*C'+R);
  ex = beta*Y; %  + 1e-3*randn(N,sum(T));
  
end
