function [A,Q,x0,Q0] = lds_pinit(ex,N,M,S,T)
%
% See lds_init
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:24 $

global LS_NL_A LS_NL_C LS_NL_Q LS_NL_R LS_NL_X0
global FA_NL_C FA_NL_R

% Initialize remaining parameters of LS
Ex0  = zeros(N,1);
Exx0 = zeros(N);
Exx1 = zeros(N);
ExxD = zeros(N);
idx  = 0;

for s = 1:S,
  
  idx  = idx(end) + (1:T(s));
  Ex   = ex(:,idx);
  
  Ex0  = Ex0 + mean(Ex,2);
  Exx0 = Exx0 + Ex*Ex';
  Exx1 = Exx1 + Ex(:,1:T(s)-1)*Ex(:,1:T(s)-1)';
  ExxD = ExxD + Ex(:,2:T(s))*Ex(:,1:T(s)-1)';
  
end

if (isempty(LS_NL_X0))
  x0 = Ex0/S;
else
  x0 = zeros(N,1);
end

if (isempty(LS_NL_Q))
  Q = Exx0/sum(T);
else
  Q = eye(N);
end
Q0 = Q;

if (isempty(LS_NL_A))
  A  = ExxD * pinv( Exx1 );
else
  A = eye(N);
end


