function [Eyy,Eyx,Exx,ExxD,ExxT,Exx1,Ex0,Exx0,T] = ...
    lds_ucs( y, ex, vx, cx, Eyy,Eyx,Exx,ExxD,ExxT,Exx1,Ex0,Exx0,T,w );
%
% lds_ics -- update LS cumulative statistics
%
% See also:
%   lds_learn
%

% $Revision: 2.0 $ $Date: 2000/04/24 17:44:25 $

if nargin<14,
  w = 1;
end

Ts = size(y,2);

Eyy  = Eyy   + w*y*y';
Eyx  = Eyx   + w*y*ex';

svx  = sum(vx,3);

Exx  = Exx   + w*( ex*ex' + (svx + svx')/2 );
ExxD = ExxD  + w*( ex(:,2:Ts)*ex(:,1:Ts-1)' + sum( cx, 3) );

ExxT = ExxT  + w*( ex(:,Ts)*ex(:,Ts)' + ( vx(:,:,Ts) + vx(:,:,Ts)' )/2 );
Exx1 = Exx1  + w*( ex(:,1)*ex(:,1)'   + ( vx(:,:,1) + vx(:,:,1)' )/2 );

Ex0  = Ex0   + w*ex(:,1);
Exx0 = Exx0  + w*( vx(:,:,1) + vx(:,:,1)' )/2;

T = T + w*Ts;
