/* $Revision: 2.1 $ $Date: 2000/06/01 14:57:53 $ */

#ifndef _LS_UTIL_H_
#define _LS_UTIL_H_

#include <math.h>

typedef double* (*sysFun)(int, double*);

extern void	
lds_clean();

extern double
lds_cost_dT( double *y, double *ex, double *vx, double *C, double *R, 
	 int N, int M );

extern void
lds_predict_dT( double *ex, double *vx, double *u,
		double *A, double *Q,
		int N,
		double *exp, double *vxp, double *cxp );

extern void
lds_filter_dT_alloc( int N, int M );

extern void
lds_filter_dT_clean( int N, int M );

extern void
lds_filter_dT_free();

extern double
lds_filter_dT( double *ex, double *vx, double *cx, double *y,
	       double *A, double *C, double *Q, double *R,
	       int N, int M,
	       double *exP, double *vxP, double *cxP );

extern void
lds_smooth_dT_alloc( int N );

extern void
lds_smooth_dT_free();

extern void
lds_smooth_dT_clean(int N );

extern void
lds_smooth_dT( double *ex, double *vx, double *exf, double *vxf,
	       double *vxfp, double *cxf,
	       double *A, double *Q, double *U,
	       int N,
	       double *exN, double *vxN, double *cxN);

extern void
lds_smooth2_dT_alloc( int N );

extern void
lds_smooth2_dT_free();

extern void
lds_smooth2_dT_clean(int N );

extern void
lds_smooth2_dT( double *ex, double *vx, double *cx, double *exf, double *vxf,
		double *vxfp,
		double *A, double *Q, double *Ap, double *Qp, double *U,
		int N,
		double *exN, double *vxN, double *cxN);


extern void
lds_forward( double *A_fun, double *C_fun, double *Q_fun, double *R_fun, 
	     double *x0, double *Q0, double *U, double *W, double *Y,
	     int N, int M, int T,
	     double *ex, double *vx, double *cx , double *cost, double *err );

extern void
lds_smooth( double *A, double *Q, double *U, 
	    double *exf, double *vxf, double *cxf,
	    int N, int T,
	    double *ex, double *vx, double *cx );

extern void
lds_smooth2( double *A, double *Q, double *C, double *R, double *U,
	     double *exf, double *vxf,
	     int N, int M, int T,
	     double *ex, double *vx, double *cx );

extern void
lds_tv_forward( sysFun A_fun, sysFun C_fun, sysFun Q_fun, sysFun R_fun, 
		double *x0, double *Q0, double *U, double *W, double *Y,
		int N, int M, int T,
		double *ex, double *vx, double *cx , 
		double *cost, double *err );

extern void
lds_tv_smooth( sysFun A, sysFun Q, double *u,
	       double *exf, double *vxf, double *cxf,
	       int N, int T,
	       double *ex, double *vx, double *cx );

extern void
lds_tv_smooth2( sysFun A, sysFun Q, sysFun C, sysFun R, double *U,
		double *exf, double *vxf,
		int N, int M, int T,
		double *ex, double *vx, double *cx );

extern double
lds_cost_state_dT( double *A, double *Q, double *ex, double *vx, double *exp, 
		   double *vxp, double *cx, int N );

extern double
lds_cost_state_0( double *x0, double *Q0, double *ex, double *vx, int N );

#endif
