%
% Markov Chain
% ============
%
% Model:
%
%   Pr( s_t | s_{t-1}, s_{t-2}, ... ) = Pr( s_t | s_{t-1} ) 
%
% Notation:
%
%   s_t		state at time 't'
%
%   N		# discrete states
%   T		duration of observation sequence
%
%   P		state transition probability matrix
%		P(i,j) = Pr( s_t = i | s_{t-1} = j )
%		dimesnton: N x N
%   p0		initial state distribution vector
%		p0(i) = Pr( s_0 = i )
%		dimension: N x 1
% Functions:
%
%   mc_sim	simulation of a MC state sequence
%   mc_infr	state inference
%   mc_learn	model parameter learning
%   mc_init	model parameter initialization
%   mc_gen	default state sequence generation
%
% Notes:
%
%   (1) State transition log probability matrix 'P' can be sparse. In that
%   case the elements not present correspond to zero probabilities or -Inf
%   log probabilities.  To convert full probability matrix 'P' to sparse log
%   probability matrix 'logPsparse' use slog.
%
% Related toolkits:
%
%   hmm		hidden Markov model toolkit
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:00 $
