% MC demo script

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:08 $

echo on
warning off
clf

% This is an MC

Pss = [ .9	0	.1 ;
	.1	.85	0  ;
	0	.15	.9 ];
% i.e., Pr( s_t = 3 | s_{t-1} = 2) = .15


% Initial state is state '1'
Ps0 = [ 1 ; 0 ; 0 ];

pause

% Simulate S=5 sequences of length T=100 using these parameters
S = 5;
T = 100;

% Assume some arbitrary distribution of sequences
pY = rand(1,S); pY = pY/sum(pY);

% ...then simulate the model using default random seed of '0'
for i=1:S,
  y{i} = mc_sim(Pss,Ps0,T,rand(1)*1e3);
end

% plot states 'y'
subplot(311); stairs(y{1}); title('States - y');

pause

% Estimate parameters of this MC given the data

% Enable printing of scores
global MC_VERBOSE
MC_VERBOSE = 1;

% Initial values are used to get parameter dims
Pss_0 = rand(3); Ps0_0 = rand(3,1);

% Learn parameters
[Pss_1,Ps0_1] = mc_learn(y, Pss_0,Ps0_0, 1e-4, pY);

printmat(Pss); printmat(Pss_0); printmat(Pss_1);
pause

echo off
