function mc_plotlab(is,slab,vpos,color)
%
% mc_plotlab -- add state labels to current plot
%
% Usage:
%   mc_plotlab(is,slab,vpos,color)
% Input:
%   is		state sequence
%   slab	list of state labels (default: '1', '2', ...)
%   vpos	vertical position of state labels (default: plot limits)
%   color	color of state labels (default: [1 0 0])  
% See also:
%   plotlab
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:09 $

if nargin<2 | isempty(slab),
  
  for n=1:max(is),
    slab{n} = sprintf('%d',n);
  end
  
end

if nargin<3 ,
  vpos = get(gca,'ylim');
end

if nargin<4,
  color = [1 0 0];
end

start = [ 1 find(diff(is))+1 ];
stop  = [ start(2:end) length(is)+1 ];

L = length(start);

pos = [start;stop;vpos(1)*ones(1,L);vpos(2)*ones(1,L)];

plotlab(slab(is(start)),pos,color);

