function s = mc_sim(Pss,Ps0,T,seed)
%
% mc_sim -- simulate Markov chain
%
% Usage:
%   s = mc_sim(Pss,Ps0,T,seed)
% Input:
%   Pss		state transition probability matrix
%   Ps0		initial state distribution vector
%   T		duration
%   seed	random seed (default 0)

%	$Revision: 2.0 $ $Date: 2000/04/24 17:43:09 $

if (nargin<4)
  seed = 0;
end

N = size(Pss,1);

rand('seed',seed);

r = rand(1);

% Cumulative sum of Pss
cPss = cumsum(Pss);

cPs0 = cumsum(Ps0);
s(1) = sum(r > cPs0)+1;

t=2;

while(t<=T)
  
  r = rand(1);
  
  s(t) = sum( r > cPss(:,s(t-1)) )+1;
  if (s(t)>N)
    s = s(1:end-1);
    break;
    end
    t = t + 1;
end
