%
% MOG - mixture of Gaussians
% ==========================
%
% Model:
%
%   c ~ Q
%   y = C_c + w_c	E[w_c] = 0, E[w_c w_c'] = R_c 
%
% Notation:
%
%   c		mixture component
%   y		observation vector
%
%   M		number of misture components
%   D		dimension of observation vector
%
%   Q		mixture weights distribution
%		Q(i) = Pr( c = i )
%   C		mixture means
%		dimension: D x M
%   R		mixture covariances
%		dimension: diagonal covariance D x M
%		           full covariance D x D x M
%
% Functions:
%
%   mog_sim	simulate a MOG
%   mog_infr	inference
%   mog_init	initialize MOG parameters
%   mog_learn	reestimate MOG parameters
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:08 $
