function [Co,Ro] = mog_collapse(Q,C,R)
%
% mog_collapse -- MOG to single Gaussian transformation
% 
% Usage:
%   [C,R] = mog_collapse(Q,C,R)
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:13 $

[M,S] = size(Q);
N = size(C,1);

full_R_flag = ndims(C)-ndims(R);

Co = zeros(N,S);
if (full_R_flag)
  Ro = zeros(N,N,S);
else
  Ro = zeros(N,S);
end

idxM = 1:M;

for s=1:S,
     
  for m=1:M,
    
    Co(:,s) = Co(:,s) + Q(m,s)*C(:,m,s);
    
  end
  
end


for s=1:S,
    
  for m=1:M,
    
    dC = C(:,m,s) - Co(:,s);
    
    if (full_R_flag)
        
      Ro(:,:,s) = Ro(:,:,s) + Q(m,s)*( R(:,:,m,s) + dC*dC' );
      
    else
      
      Ro(:,s) = Ro(:,s) + Q(m,s)*( R(:,m,s) + dC.^2 );
            
    end
    
  end
  
end
