function cost = mog_cost(Ec, Eyc, Eyyc, Q, C, R, T)
%
% mog_cost -- MOG cost function evaluation
%
% Usage:
%	cost = mog_cost(Ec, Eyc, Eyyc, Q, C, R, T)
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:13 $

[M,N] = size(Q);
d = ndims(R)-ndims(C);

const = log(2*pi);
cost = 0;

for c=1:M,
  
  if (Q(c))
    
    if (d),
      cost = cost -log(Q(c)+realmin)*Ec(c) ...
	     + trace( inv(R(:,:,c))*( ...
		 Eyyc(:,:,c) - C(:,c)*Eyc(:,c)' ...
		 - Eyc(:,c)*C(:,c)' ...
		 + C(:,c)*Ec(c)*C(:,c)' )/2) ...
	     + ( log(det(R(:,:,c))) + log(2*pi)*M )*Ec(c)/2;
    else
      cost = cost - log(Q(c)+realmin)*Ec(c) ... 
	     + sum( ( Eyyc(:,c) - 2*C(:,c).*Eyc(:,c) ...
		      + C(:,c).^2*Ec(c) )./R(:,c) )/2 ...
	     + ( log(prod(R(:,c))) + const*M )*Ec(c)/2;
    end   
    
  end
  
end
