function [p,pq] = mog_eval(x,q,c,r)
%
% mog_eval -- evaluate mixture of Gaussians
%
% Evaluate 'S' Gaussian mixture (MOG) functions on a set of 'N' data 
% vectors 'x' of dimenstion 'DIM'. Each of 'S' MOGs (states) has 'M' mixture 
% componets with log weights 'q', means 'c', and variances 'r'.
%
% Usage:
%   [p,pq] = mog_eval(x,q,c,r)
% Input:
%   x	data [ DIM x N ]
%   q	mixture weights [ mixture x state ]
%   c	mean [ DIM x mixture x state ]
%   r	variance:	diagonal [ DIM x mixture x state ] or 
%			full [ DIM x DIM x mixture x state ]
% Output:
%   p	log Pr(data|state) [ state x N ]
%   pq	log Pr(data,mixture|state) [ mixture x state x N ]
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:13 $

% mog_eval is implemented as a MEX file.  You need to compile mog_eval.c in
% order to use this function.  See 'makefile.m'
