function [Q,C,R] = mog_max( Ec,Eyc,Eyyc,T, Q,C,R )
%
% mog_max -- maximization of MOG parameters
%
% Usage:
%   [Q,C,R] = mog_max( Ec,Eyc,Eyyc,T, Q,C,R )
%

%	$Revision: 2.0 $ $Date: 2000/04/24 17:42:15 $

M = size(Ec,1);
N = 1;
D = size(Eyc,1);
d = ndims(Eyyc) - ndims(Eyc);

Q = zeros(M,N);
C = zeros(D,M,N);
if (d)
  R = zeros(D,D,M,N);
else
  R = zeros(D,M,N);
end

Q = Ec * sinv( diag(sum(Ec)) );

for c=1:M,
        
  if Q(c)
    
    C(:,c)  = Eyc(:,c) / Ec(c);
    
    if (d),
      R(:,:,c) = ...
	  ( Eyyc(:,:,c) - C(:,c)*Eyc(:,c)' ) / ...
	  Ec(c);
    else
      R(:,c) = ...
	  ( Eyyc(:,c) - C(:,c).*Eyc(:,c) ) / ...
	  Ec(c);
    end
    
  end
  
end % for c
